import pickle
import socket
import threading

# A list of empty strings to contain the chat references
# must be equal to the number of display lines in the gui
txtList = [" " for i in range(16)]

# clients holds the threads which serve each client
clients = []       

# Our thread class:
class ClientThread ( threading.Thread ):

    # Create this client handling thread
    def __init__ ( self, channel, details ):

      self.channel = channel
      self.details = details
      self.position = [0,0,0]
      self.message = ""
      self.newPosition = [0,0,0]
      self.newMessage = ""

      # listen for a client name being sent to us
      self.name = channel.recv(1024)
      print self.name, 'connected'

      # call the superclass's constructor
      threading.Thread.__init__ ( self )

    def run ( self ):
        # while client is connected
        while True:
            try:
                # listen for data from client
                data = self.channel.recv(1024)
                if data:
                    # un-pickle the data
                    self.newMessage = pickle.loads(data)
                    # if there is a message, add it to the list
                    if not self.newMessage == "":
                        txtList.append(self.name + ':' + self.newMessage)
                # slice off the last 16 messages to send back
                txtToSend = txtList[-16:]
                # pickle it and send
                toSend = pickle.dumps(txtToSend)
                self.channel.send(toSend)
            except:
                # Nope, we have lost the connection
                self.channel.close()
                print 'Connection to', self.name, 'lost'
                return False

# Set up the server to stream data through port 80
server = socket.socket ( socket.AF_INET, socket.SOCK_STREAM )
server.bind ( ( '', 80 ) )
server.listen ( 5 )


# Listen for connections indefinitely,
# when one is received, spawn a new thread to serve it.
while True:
    channel, details = server.accept()
    print 'Received connection:', details [ 0 ]
    t = ClientThread ( channel, details )
    t.start()
    clients.append(t)

# clean-up the server   
server.close()

